<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'List' => '\\StructType\\_List',
            'ArrayOfListCriterion' => '\\ArrayType\\ArrayOfListCriterion',
            'ListCriterion' => '\\StructType\\ListCriterion',
            'EntityBase' => '\\StructType\\EntityBase',
            'ListResponse' => '\\StructType\\ListResponse',
            'ArrayOfUnitObject' => '\\ArrayType\\ArrayOfUnitObject',
            'UnitObject' => '\\StructType\\UnitObject',
            'Accessibility' => '\\StructType\\Accessibility',
            'Address' => '\\StructType\\Address',
            'Availability' => '\\StructType\\Availability',
            'FloorPlan' => '\\StructType\\FloorPlan',
            'UnitDetails' => '\\StructType\\UnitDetails',
            'rentMatrix' => '\\StructType\\RentMatrix',
            'row' => '\\StructType\\Row',
            'options' => '\\StructType\\Options',
            'option' => '\\StructType\\Option',
            'Concessions' => '\\StructType\\Concessions',
            'UserAuthInfo' => '\\StructType\\UserAuthInfo',
            'GetRentMatrix' => '\\StructType\\GetRentMatrix',
            'ArrayOfInt' => '\\ArrayType\\ArrayOfInt',
            'GetRentMatrixResponse' => '\\StructType\\GetRentMatrixResponse',
            'ArrayOfRentMatrix' => '\\ArrayType\\ArrayOfRentMatrix',
            'RentMatrix' => '\\StructType\\RentMatrix_1',
            'GetFloorPlanGroupsByProperty' => '\\StructType\\GetFloorPlanGroupsByProperty',
            'GetFloorPlanGroupsByPropertyResponse' => '\\StructType\\GetFloorPlanGroupsByPropertyResponse',
            'PickListObject' => '\\StructType\\PickListObject',
            'ArrayOfPicklistItem' => '\\ArrayType\\ArrayOfPicklistItem',
            'PicklistItem' => '\\StructType\\PicklistItem',
            'WebServiceLogHeader' => '\\StructType\\WebServiceLogHeader',
            'GetFloorPlanIDAndName' => '\\StructType\\GetFloorPlanIDAndName',
            'GetFloorPlanIDAndNameResponse' => '\\StructType\\GetFloorPlanIDAndNameResponse',
            'GetUnitsByProperty' => '\\StructType\\GetUnitsByProperty',
            'GetUnitsByPropertyResponse' => '\\StructType\\GetUnitsByPropertyResponse',
        );
    }
}
